/* 
  This program implements the ECIES public key encryption scheme based on the
  NIST B163 elliptic curve and the XTEA block cipher. The code was written
  as an accompaniment for an article published in phrack #63 and is released to
  the public domain.
  Original author: Phrack Staff
  Ported to Atmel AVR: Jiri Pittner <jiri@pittnerovi.com>

*/


#include "ecc.h"

/*missing in avr stdlib*/
/*
int strspn(const char *string, const char *charset)
{   
const char *p, *q;  
for (q = string; *q != '\0'; ++q) {
           for (p = charset; *p != '\0' && *p != *q; ++p);
	   if (*p == '\0') break;  
         }
return (q - string);
}
*/


typedef bitstr_t elem_t;           /* this type will represent field elements */

elem_t poly;                                      /* the reduction polynomial */
elem_t coeff_b, base_x, base_y;

typedef bitstr_t exp_t;
exp_t base_order;

